########################################################################
#
#	NpCategoryCsv.pl
#
#	y֐z
#	instance				
#
#	yz
#	Ver	1.00	2010.05.17	vx TY	VK쐬
#	Ver	1.10	2011.08.25	vx TY	EFuTCgɑΉB
#
#	Copyright (C) 2010 Shitaro Kubuki. All Rights Reserved
#
package MT::Plugin::NpCategoryCsv;

use strict;
use MT;
use MT::Plugin;
use base qw( MT::Plugin );
use vars qw($PLUGIN_NAME $VERSION);
$PLUGIN_NAME = 'NAWAGATE plugin Click Pong Category CSV basic';
$VERSION = '1.10';

my $plugin = MT::Plugin::NpCategoryCsv->new({
    id => 'npcategorycsv',
    key => __PACKAGE__,
    name => $PLUGIN_NAME,
    version => $VERSION,
    description => "<__trans phrase='Import / Export data of Category(Folder) by CSV format.'>",
    author_name => "<__trans phrase='Shintaro Kubuki'>",
    author_link => 'http://nawagate.com/',
    doc_link => 'http://appstream.jp/category-csv/index.html',
    l10n_class => 'NpCategoryCsv::L10N',
    registry => {
		applications => {
			cms => {
				methods =>
				{
					np_category_csv_display_import => '$NpCategoryCsv::NpCategoryCsv::CMS::display_import',
					np_category_csv_import => '$NpCategoryCsv::NpCategoryCsv::CMS::import',
					np_category_csv_display_export => '$NpCategoryCsv::NpCategoryCsv::CMS::display_export',
					np_category_csv_export => '$NpCategoryCsv::NpCategoryCsv::CMS::export',
				},
				menus =>
				{
					'tools:np_category_csv_import' =>
					{
						label => 'CSV Category Import',
						order => 10001,
						mode => 'np_category_csv_display_import',
						view => "blog",
					},
					'tools:np_category_csv_export' =>
					{
						label => 'CSV Category Export',
						order => 10002,
						mode => 'np_category_csv_display_export',
						view => "blog",
					},
				},
			},
		},
    },
});

MT->add_plugin($plugin);

sub instance { $plugin; }

1;
