########################################################################
#
#	CMS.pm
#
#	y֐z
#	display_import			C|[gʕ\
#	import					C|[g
#	display_export			GNX|[gʕ\
#	export					GNX|[g
#
#	yz
#	Ver	1.00	2010.05.17	vx TY	VK쐬
#	Ver	1.10	2011.08.25	vx TY	EFuTCgɑΉB
#
#	Copyright (C) 2010 Shitaro Kubuki. All Rights Reserved
#
package NpCategoryCsv::CMS;

use strict;
use warnings;
use CustomFields::Util qw( get_meta save_meta );
use MT::Util qw( dirify );
use MT::Blog;
use MT::Author;
use MT::I18N qw( guess_encoding encode_text );
use HTTP::Date;
use NpLibrary::CsvObject;
use NpLibrary qw( lib_get_dir_separator lib_doLog lib_get_system_charset lib_app_print lib_get_csv_items lib_get_item_id );

use vars qw( @CATEGORY_CSVS @FOLDER_CSVS $INDEX_ID $INDEX_PARENT_ID $INDEX_LABEL );

# JeSCSVe[u z̏͗̏o͏ƂȂB
@CATEGORY_CSVS = (
#								vpeB			ftHg		^Cg
	new NpLibrary::CsvObject(	'id',				'',				"Category ID"																		),
#	new NpLibrary::CsvObject(	'blog_id',			'',				""																					),
	new NpLibrary::CsvObject(	'parent',			'',				"Parent category ID"																),
	new NpLibrary::CsvObject(	'label',			'',				"Label\n *required"																	),
	new NpLibrary::CsvObject(	'author_id',		'',				"User name(ID)"																		),
	new NpLibrary::CsvObject(	'ping_urls',		'',				"Track back URL\n*Please change line when you register two or more destinations."	),
	new NpLibrary::CsvObject(	'description',		'',				"Explanation"																		),
	new NpLibrary::CsvObject(	'allow_pings',		'',				"Track back permission.\n0:Not permission\n1:permission"							),
	new NpLibrary::CsvObject(	'basename',			'',				"Output file/Folder name"															),
);

# tH_CSVe[u z̏͗̏o͏ƂȂB
@FOLDER_CSVS = (
);

$INDEX_ID = 0;
$INDEX_PARENT_ID = 1;
$INDEX_LABEL = 2;


########################################################################
#
#	y֐z
#	display_import			C|[gʕ\
#
#	y@\z
#	C|[gʂ̕\s܂B
#
#	yz
#	Ver	1.00	2010.05.17	vx TY	VK쐬
#
sub display_import
{
	my $app = shift;
	my $blog_id = $app->param('blog_id');

	# JeS̊Ǘ錠邩`FbNisuperuserj
	my $perms = $app->permissions;
	return $app->return_to_dashboard( permission => 1 )
	  if $perms
		  && ( !( $perms->can_edit_config || $perms->can_administer_blog ) );

	my %param;
	$param{blog_id} = $blog_id;
	my $view = $app->param('view') || 'blog';
	$param{view} = $view;
	$app->load_tmpl( 'category_csv_import.tmpl', \%param );
}
########################################################################
#
#	y֐z
#	import					C|[g
#
#	y@\z
#	C|[g̃GWƂȂ鏈s܂B
#
#	yz
#	Ver	1.00	2010.05.17	vx TY	VK쐬
#
sub import
{
	my $app = shift;
    my $user    = $app->user;
	my $blog_id = $app->param('blog_id')
		or return $app->error( $app->translate("Please select a blog.") );
	my $class = $app->param('class')
		or return $app->error( $app->translate("Please select a category type.") );
    my $blog = MT::Blog->load($blog_id)
		or return $app->error( $app->translate("Load of blog '[_1]' failed: [_2]", $blog_id, MT::Blog->errstr));
	$app->param('file') or return $app->error( $app->translate("Please input file name.") );

	# `FbN
		# JeS̊ݒҏW錠邩`FbN
	my $perms = $app->permissions;
	return $app->error( $app->translate("You do not have export permissions") )
		unless $perms && $perms->can_edit_config;
		# magic_tokenHTTPp[^[L`FbN
	$app->validate_magic() or return;

 	# NX𔻒
	my $class_name = ($class eq 'category') ? 'category' : 'folder';
	my $category_class = MT->model($class_name);
	my @csv_objects = ($class eq 'category') ? @CATEGORY_CSVS : @FOLDER_CSVS;

	my $q = $app->{query};
	my $fh = $q->upload('file');
	my @file = ();
	my $buffer = "";
	foreach my $record (<$fh>)
	{
		if ( MT->version_number >= 5 )
		{
			$buffer .= Encode::decode('shift_jis', $record);
		}
		else
		{
			$buffer .= encode_text($record, 'shift_jis', lib_get_system_charset($app));
		}
		next if ( ($buffer =~ s/"/"/g) % 2 );
		push( @file, $buffer );
		$buffer = "";
	}

	$app->{no_print_body} = 1;

	local $| = 1;
	$app->send_http_header('text/html');

	my $param;

	lib_app_print($app, $app->build_page( 'category_csv_import_start.tmpl', $param ) );

	# ^Cgs̐ǂ
	my @custom_ids = ();
	foreach my $record (@file)
	{
		my @items = lib_get_csv_items( $file[0], ',' );
		if ( $items[$INDEX_ID] eq $app->translate($csv_objects[0]->{title}) )
		{
			shift( @file );
		}
		last;
	}
	# Csvt@C`FbN
	my $error = 0;
	my $row = 0;
	foreach my $record (@file)
	{
		$row++;
		my @items = lib_get_csv_items( $record, ',' );
		for (my $index = 0; $index < $#csv_objects + 1; $index++)
		{
			my $property_name = $csv_objects[$index]->{property_name};
			my $value = $items[$index];
			# JeSID
			if ( $property_name eq 'id' )
			{	# ݃`FbN
				next if ( $value eq '' );
				my $category = $category_class->load( { id => $value, blog_id => $blog_id } );
				unless ( $category )
				{
					if ($class eq 'category')
					{
						lib_app_print($app, $app->translate("Error: Category link to Category ID not found. Row.[_1] ([_2])", $row, $items[$INDEX_LABEL]) . "\n" );
					}
					else
					{
						lib_app_print($app, $app->translate("Error: Folder link to Folder ID not found. Row.[_1] ([_2])", $row, $items[$INDEX_LABEL]) . "\n" );
					}
					$error = 1;
				}
			}
			# O
			if ( $property_name eq 'label' )
			{	# K{`FbN
				if ( $value eq '' )
				{
					lib_app_print($app, $app->translate("Error: Label is required. Row.[_1] ([_2])", $row, $items[$INDEX_LABEL]) . "\n" );
					$error = 1;
				}
				# d`FbNiJeŜ݁j
				if ( $class eq 'category')
				{
					my $parent_id = 0;
					if ( $items[$INDEX_PARENT_ID] ne '' )
					{
						$parent_id = $items[$INDEX_PARENT_ID];
					}
					my @categories = $category_class->load( { blog_id => $blog_id, label => $value, parent => $parent_id } );
					next unless ( @categories );
					if ( $#categories + 1 == 1 )
					{
						next if ( $categories[0]->id eq $items[$INDEX_ID] );
					}
					lib_app_print($app, $app->translate("Error: The category name \'[_2]\' conflicts with another category. Top-level categories and sub-categories with the same parent must have unique names. Row.[_1] ([_2])", $row, $items[$INDEX_LABEL]) . "\n" );
					$error = 1;
				}
			}
			#x[Xl[
			if ( $property_name eq 'basename' )
			{
				next if ( $value eq '' );
				# d`FbN
				my $parent_id = 0;
				if ( $items[$INDEX_PARENT_ID] ne '' )
				{
					$parent_id = $items[$INDEX_PARENT_ID];
				}
				my @categories = $category_class->load( { blog_id => $blog_id, basename => $value, parent => $parent_id } );
				next unless ( @categories );
				if ( $#categories + 1 == 1 )
				{
					next if ( $categories[0]->id eq $items[$INDEX_ID] );
				}
				if ($class eq 'category')
				{
					lib_app_print($app, $app->translate("Error: The category basename \'[_2]\' conflicts with another category. Top-level categories and sub-categories with the same parent must have unique basename. Row.[_1] ([_2])", $row, $items[$INDEX_LABEL]) . "\n" );
				}
				else
				{
					lib_app_print($app, $app->translate("Error: The folder basename \'[_2]\' conflicts with another folder. Folders with the same parent must have unique basenames. Row.[_1] ([_2])", $row, $items[$INDEX_LABEL]) . "\n" );
				}
				$error = 1;
			}
			# [U[
			if ( $property_name eq 'author_id' )
			{	# ݃`FbN
				next if ( $value eq '' );
				my $author = MT::Author->load( lib_get_item_id( $value ) );
				unless ( $author )
				{
					$value =~ s/\((\d+)\)$//;
					$author = MT::Author->load( {name => $value,} );
					unless ( $author )
					{
						lib_app_print($app, $app->translate("Error: User not found. Row.[_1] ([_2])", $row, $items[$INDEX_LABEL]) . "\n" );
						$error = 1;
					}
				}
			}
			# eJeSID
			if ( $property_name eq 'parent' )
			{	# ݃`FbN
				next if ( $value eq '' );
				next if ( $value eq '0' );
				my $category = $category_class->load( { id => $value, blog_id => $blog_id } );
				unless ( $category )
				{
					if ($class eq 'category')
					{
						lib_app_print($app, $app->translate("Error: Category link to Parent category ID not found. Row.[_1] ([_2])", $row, $items[$INDEX_LABEL]) . "\n" );
					}
					else
					{
						lib_app_print($app, $app->translate("Error: Folder link to Parent folder ID not found. Row.[_1] ([_2])", $row, $items[$INDEX_LABEL]) . "\n" );
					}
					$error = 1;
				}
			}
		}
	}
	if ( $error == 1 )
	{
		lib_app_print($app, $app->build_page( "category_csv_import_end.tmpl", $param ) );
		return 1;
	}

	# o^
	foreach my $record (@file)
	{
		my @items = lib_get_csv_items( $record, ',' );
		# JeS
		my $category = $category_class->load( $items[$INDEX_ID] );
		unless ( $category )
		{
			my $parent_id = 0;
			if ( $items[$INDEX_PARENT_ID] ne '' )
			{
				$parent_id = $items[$INDEX_PARENT_ID];
			}
			$category = $category_class->load( { blog_id => $blog_id, label => $items[$INDEX_LABEL], parent => $parent_id } );
			unless ( $category )
			{
				$category = $category_class->new;
			}
		}

			# uOID
		$category->blog_id( $blog_id );
			# ̑
		for (my $index = 0; $index < $#csv_objects + 1; $index++)
		{
			my $property_name = $csv_objects[$index]->{property_name};
			my $default = $csv_objects[$index]->{default};
			my $value = $items[$index];
			# id ͏㏑Ȃ
			next if ( $property_name eq 'id' );
			if ($category->column_defs->{$property_name}->{'type'} eq 'datetime')
			{
				my $time = HTTP::Date::str2time( $value );
				next unless ( $time );
				my @times = MT::Util::offset_time_list( $time, $blog_id );
				$value = sprintf( "%04d%02d%02d%02d%02d%02d", $times[5]+1900, $times[4]+1, @times[3,2,1,0] );
			}
			if ( $property_name eq 'author_id' )
			{
				if ( $value eq '' )
				{
					$value = $user->id;
				}
				else
				{
					my $author = MT::Author->load( lib_get_item_id( $value ) );
					unless ( $author )
					{
						$value =~ s/\((\d+)\)$//;
						$author = MT::Author->load( {name => $value,} );
					}
					if ( $author )
					{
						$value = $author->id;
					}
					else
					{
						$value = $user->id;
					}
				}
			}
			if ( $property_name eq 'parent' )
			{
				if ( $value eq '' )
				{
					$value = 0;
				}
			}
			if ( ( $default ne '' ) && ( $value eq '' ) )
			{
				$value = $blog->$default;
			}
			$category->$property_name($value);
		}
		$category->save;
		if ($class eq 'category')
		{
			lib_app_print($app, $app->translate("Data of category imported. ID.[_1] ([_2])", $category->id, $category->label) . "\n" );
		}
		else
		{
			lib_app_print($app, $app->translate("Data of folder imported. ID.[_1] ([_2])", $category->id, $category->label) . "\n" );
		}
	}

	$param->{import_success} = '1';
	lib_app_print($app, $app->build_page( "category_csv_import_end.tmpl", $param ) );

	close $fh if $fh;

	return 1;

}
########################################################################
#
#	y֐z
#	display_export			GNX|[gʕ\
#
#	y@\z
#	GNX|[gʂ̕\s܂B
#
#	yz
#	Ver	1.00	2010.05.17	vx TY	VK쐬
#
sub display_export
{
	my $app = shift;
	my $blog_id = $app->param('blog_id');

	# JeS̊Ǘ錠邩`FbNisuperuserj
	my $perms = $app->permissions;
	return $app->return_to_dashboard( permission => 1 )
	  if $perms
		  && ( !( $perms->can_edit_config || $perms->can_administer_blog ) );

	my %param;
	$param{blog_id} = $blog_id;
	my $view = $app->param('view') || 'blog';
	$param{view} = $view;
	$app->load_tmpl( 'category_csv_export.tmpl', \%param );
}
########################################################################
#
#	y֐z
#	export					GNX|[g
#
#	y@\z
#	GNX|[g̃GWƂȂ鏈s܂B
#
#	yz
#	Ver	1.00	2010.05.17	vx TY	VK쐬
#
sub export
{
	my $app = shift;
	my $blog_id = $app->param('blog_id')
		or return $app->error( $app->translate("Please select a blog.") );
	my $class = $app->param('class')
		or return $app->error( $app->translate("Please select a category type.") );
    my $blog = MT::Blog->load($blog_id)
		or return $app->error(
			$app->translate(
				"Load of blog '[_1]' failed: [_2]", $blog_id,
				MT::Blog->errstr
			)
		);

	# `FbN
		# JeS̊ݒҏW錠邩`FbN
	my $perms = $app->permissions;
	return $app->error( $app->translate("You do not have export permissions") )
		unless $perms && $perms->can_edit_config;
		# magic_tokenHTTPp[^[L`FbN
	$app->validate_magic() or return;

	# NX𔻒
	my $class_name = ($class eq 'category') ? 'category' : 'folder';
	my $category_class = MT->model($class_name);
	my @csv_objects = ($class eq 'category') ? @CATEGORY_CSVS : @FOLDER_CSVS;

	# CSV t@C̐
	my $file = dirify( $blog->name );
	my @ts = localtime(time);
	if ( $file ne '' )
	{
		$file = sprintf( "%s-%s-%04d%02d%02d%02d%02d%02d.csv",
			$class, $file, $ts[5] + 1900, $ts[4] + 1, @ts[ 3, 2, 1, 0 ]);
	}
	else
	{
		$file = sprintf( "%s-blog_id_%03d-%04d%02d%02d%02d%02d%02d.csv",
			$class, $app->param('blog_id'), $ts[5] + 1900, $ts[4] + 1, @ts[ 3, 2, 1, 0 ]);
	}

	printf( "Content-Type: application/octet-stream\n" );
	printf( "Content-Disposition: attachment; filename=%s\n", $file );
	printf( "\n" );

	# ^Cgs̐
	my @buffer = ();
		# JeS
	foreach my $mt_category_csv (@csv_objects)
	{
		push( @buffer, encode_text($app->translate($mt_category_csv->{title}), lib_get_system_charset($app), 'shift_jis'));
	}
		# ^Cgs̏o
	my $buffer = join( ',', map( {(s/"/""/g or /[\r\n,]/) ? qq("$_") : (/[\D]/) ? qq("$_") : qq("'$_")} @buffer ) );
	printf( "%s\n", $buffer );

	# ڍ׍s̐
	my @categories = $category_class->load({ blog_id => $blog_id });
	foreach my $category (@categories)
	{
		# 
		@buffer = ();
		# JeS
		my $column_names = $category->column_names;
		my @column_names = @$column_names;

		my %values = ();
		foreach my $column_name ( @column_names )
		{
			if ( $category->column_defs->{$column_name}->{'type'} eq 'datetime' )
			{
				$values{$column_name} = MT::Util::format_ts( '%Y-%m-%d %H:%M:%S', $category->$column_name, undef );
				next;
			}
			if ( $column_name eq 'author_id' )
			{
				$values{$column_name} = '';
				my $author = MT::Author->load( $category->$column_name );
				if ( $author )
				{
					$values{$column_name} = $author->name . '(' . $author->id . ')';
				}
				next;
			}
			$values{$column_name} = $category->$column_name;
		}
		foreach my $mt_category_csv (@csv_objects)
		{
			if ( exists($values{$mt_category_csv->{property_name}}) )
			{
				push( @buffer, $values{$mt_category_csv->{property_name}} );
			}
			else
			{
				push( @buffer, "" );
			}
		}
		# ڍ׍s̏o
		$buffer = join( ',', map( {(s/"/""/g or /[\r\n,]/) ? qq("$_") : (/[\D]/) ? qq("$_") : qq("'$_")} @buffer ) );
		$buffer = encode_text($buffer, lib_get_system_charset($app), 'shift_jis');
		printf( "%s\n", $buffer );
	}

	exit;
}

1;
