########################################################################
#
#	ja.pm
#
#	【関数】
#
#	【履歴】
#	Ver	1.00	2010.05.17	久富木 慎太郎	新規作成
#	Ver	1.10	2011.08.25	久富木 慎太郎	ウェブサイトに対応。
#
#	Copyright (C) 2010 Shitaro Kubuki. All Rights Reserved
#
package NpCategoryCsv::L10N::ja;

use strict;

use base 'NpCategoryCsv::L10N::en_us';
use vars qw( %Lexicon );

require utf8 if (MT->version_number >= 5); 


# The following is the translation table.
%Lexicon = (
## NpCategoryCsv.pl
	'Import / Export data of Category(Folder) by CSV format.' => 'CSV形式でカテゴリ（フォルダ）の情報をインポート／エクスポートします。',
	'Shintaro Kubuki' => '久富木 慎太郎',
	'CSV Category Import', => 'CSVカテゴリインポート',
	'CSV Category Export', => 'CSVカテゴリエクスポート',

## lib/NpCategoryCsv/CMS.pm

	'Category ID' => 'カテゴリID',
	"Label\n *required" => "名前\n※必須項目です。",
	'User name(ID)' => 'ユーザー名(ID)',
	"Track back URL\n*Please change line when you register two or more destinations." => "トラックバックURL\n※複数の送信先を登録する場合は、改行してください。",
	'Explanation' => '説明',
	'Parent category ID' => '親カテゴリID',
	"Track back permission.\n0:Not permission\n1:permission" => "トラックバックを許可\n0：許可しない\n1：許可する",
	'Output file/Folder name' => '出力ファイル/フォルダ名',
	'Folder ID' => 'フォルダID',
	'Parent folder ID' => '親フォルダID',
	'Path (folder name)' => 'パス（フォルダ名）',
	'Please select a blog.' => 'ブログを選択してください。',
	'Please select a category type.' => 'カテゴリタイプを選択してください。',
	'Load of blog \'[_1]\' failed: [_2]' => 'ブログ(ID:[_1])をロードできませんでした: [_2]',
	'Please input file name.', => 'インポートファイルを入力してください。',
	'You do not have export permissions' => 'エクスポートする権限がありません。',
	'Error: Category link to Category ID not found. Row.[_1] ([_2])' => 'Error: カテゴリIDに対応するカテゴリが見つかりませんでした。Row.[_1] ([_2])',
	'Error: Folder link to Folder ID not found. Row.[_1] ([_2])' => 'Error: フォルダIDに対応するフォルダが見つかりませんでした。Row.[_1] ([_2])',
	'Error: Label is required. Row.[_1] ([_2])' => 'Error: 名前は必須項目です。Row.[_1] ([_2])',
	'Error: The category name \'[_2]\' conflicts with another category. Top-level categories and sub-categories with the same parent must have unique names. Row.[_1] ([_2])' => 'Error: 名前\'[_2]\'は他のカテゴリと衝突しています。同じ階層にあるカテゴリの名前は一意でなければなりません。Row.[_1] ([_2])',
	'Error: The category basename \'[_2]\' conflicts with another category. Top-level categories and sub-categories with the same parent must have unique basename. Row.[_1] ([_2])' => 'Error: 名前\'[_2]\'は他のカテゴリと衝突しています。同じ階層にあるカテゴリのベースネームは一意でなければなりません。Row.[_1] ([_2])',
	'Error: The folder basename \'[_2]\' conflicts with another folder. Folders with the same parent must have unique basenames. Row.[_1] ([_2])' => 'Error: \'[_2]\'は他のフォルダと衝突しています。同じ階層にあるフォルダの名前(ベースネーム)は一意でなければなりません。Row.[_1] ([_2])',
	'Error: User not found. Row.[_1] ([_2])', => 'Error: ユーザーが見つかりませんでした。Row.[_1] ([_2])',
	'Error: Category link to Parent category ID not found. Row.[_1] ([_2])' => 'Error: 親カテゴリIDに対応するカテゴリが見つかりませんでした。Row.[_1] ([_2])',
	'Error: Folder link to Parent folder ID not found. Row.[_1] ([_2])' => 'Error: 親フォルダIDに対応するフォルダが見つかりませんでした。Row.[_1] ([_2])',
	'Data of category imported. ID.[_1] ([_2])', => 'カテゴリの情報をインポートしました。ID.[_1]([_2])',
	'Data of folder imported. ID.[_1] ([_2])', => 'フォルダの情報をインポートしました。ID.[_1]([_2])',

## tmpl/csv_import.tmpl
	'You must select a blog to import.' => 'インポート先のブログを選択してください。',
	'CATEGORY_IMPORT_MESSAGE' => '
Movable TypeにCSV形式のカテゴリ（フォルダ）の情報をインポートします。<br />
基本的なデータ（名前、出力ファイル/フォルダ名、カスタムフィールド）を上書き、または新規作成できます。<br />
<br />
インポートの仕様については以下のとおりとなります。<br />
・CSVのフォーマットはカンマ区切り（Microsoft Office ExcelにCSV形式に準拠）<br />
・１つのセルに複数の値がある場合は「|」区切り<br />
・カテゴリID（フォルダID）とユーザーIDの存在チェック以外のエラーは無視します。<br />
・カテゴリID（フォルダID）が空白の場合、カテゴリ（フォルダ）を新規作成します。<br />
・カテゴリID（フォルダID）が存在する場合は該当カテゴリ（フォルダ）を上書きします。<br />
・カスタムフィールドが対応しない場合はその列を無視します。<br />
',
	'Import data into' => 'インポート先',
	'Select a blog to import.' => 'インポート先のブログを選択してください。',
	'Select blog' => 'ブログを選択してください。',
	'Category Type' => 'カテゴリのタイプ',
	'Category' => 'カテゴリ',
	'Folder' => 'フォルダ',
	'Import file' => 'インポートファイル',
	'Please upload import file.' => 'インポートファイルをアップロードしてください。',
	'More options' => 'その他のオプション',
	'Import File Encoding' => 'インポートするファイルの文字コード',
	'Import Category(Folder) (s)' => 'カテゴリ（フォルダ）をインポート (s)',
	'Import Category(Folder)' => 'カテゴリ（フォルダ）のインポート',

## tmpl/csv_import_start.tmpl
	'Importing...' => 'インポートを開始します...',
	'Importing categories(folders)' => 'カテゴリ（フォルダ）をインポートしています',
	'Importing as user \'[_1]\'' => 'ユーザー[_1]としてインポートしています',

## tmpl/csv_import_end.tmpl
	'All data imported successfully!' => 'すべてのデータをインポートしました。',
	'An error occurred during the import process. Please check your import file.' => 'インポートの途中でエラーが発生しました。インポートファイルを確認してください。',

## tmpl/csv_export.tmpl
	'You must select a blog to export.' => 'エクスポートするブログを選択してください。',
	'CATEGORY_EXPORT_MESSAGE' => '
Movable Typeからカテゴリ（フォルダ）の情報をCSV形式でエクスポートします。<br />
基本的なデータ（名前、出力ファイル/フォルダ名、カスタムフィールド）をダウンロードできます。<br />
エクスポートの仕様については以下のとおりとなります。<br />
・CSVのフォーマットはカンマ区切り（Microsoft Office ExcelにCSV形式に準拠）<br />
・１つのセルに複数の値がある場合は「|」区切り<br />
',
	'Blog to Export' => 'エクスポートするブログ',
	'Select a blog for exporting.' => 'エクスポートするブログを選択してください。',
	'Change blog' => 'ブログを変更',
	'Select blog' => 'ブログを選択',
	'Category' => 'カテゴリ',
	'Folder' => 'フォルダ',
	'Export Category(Folder) (s)' => 'カテゴリ（フォルダ）をエクスポート (s)',
	'Export Category(Folder)' => 'カテゴリ（フォルダ）をエクスポート',
);

1;
