########################################################################
#
#	NpLibrary.pm
#
#	y֐z
#	lib_get_dir_separator	؂蕶擾
#	lib_doLog				Oo͏
#	lib_get_system_charset	VXeR[h擾
#	lib_app_print			vg
#	lib_get_item_id			hc擾
#	lib_get_csv_items		bruڒl擾
#
#	yz
#	Ver	1.00	2010.05.17	vx TY	VK쐬
#
#	Copyright (C) 2010 Shitaro Kubuki. All Rights Reserved
#
package NpLibrary;

use strict;
use base 'Exporter';

our @EXPORT_OK = qw(
	lib_get_dir_separator
	lib_doLog
	lib_get_system_charset
	lib_app_print
	lib_get_item_id
	lib_get_csv_items
);

########################################################################
#
#	y֐z
#	lib_get_dir_separator	؂蕶擾
#
#	y@\z
#	pX̋؂蕶擾B
#
#	yz
#	Ver	1.00	2010.08.10	vy TY	VK쐬
#
sub lib_get_dir_separator
{
	require File::Spec;
	my $sep = File::Spec->catdir( 'MT', 'MT' );
	$sep =~ s/MT//g;
	return $sep;
}
########################################################################
#
#	y֐z
#	lib_doLog				Oo͏
#
#	y@\z
#	Oo͂B
#
#	yz
#	Ver	1.00	2010.05.17	vy TY	VK쐬
#
sub lib_doLog
{
	my ($msg) = @_;
	return unless defined($msg);

	my $log = MT::Log->new;
	$log->message($msg);
	$log->save or die $log->errstr;
}
########################################################################
#
#	y֐z
#	lib_get_system_charset	VXeR[h擾
#
#	y@\z
#	MovableTypẽo[WɊÂR[h擾B
#
#	yz
#	Ver	1.00	2010.05.17	vy TY	VK쐬
#
sub lib_get_system_charset
{
	my $app = shift;

	if ( MT->version_number >= 5 )
	{
		return 'utf-8';
	}
	return $app->charset 
}
########################################################################
#
#	y֐z
#	lib_app_print			vg
#
#	y@\z
#	MovableTypẽo[WɊÂvgsB
#
#	yz
#	Ver	1.00	2010.05.17	vx TY	VK쐬
#
sub lib_app_print
{
    my ($app, $text) = @_;

	if ( MT->version_number >= 5 )
	{
		$app->print_encode( $text );
	}
	else
	{
		$app->print( $text );
	}
}
########################################################################
#
#	y֐z
#	lib_get_item_id			hc擾
#
#	y@\z
#	ڂ̒l()ň͂܂ꂽl擾܂B
#
#	yz
#	Ver	1.00	2010.05.17	vx TY	VK쐬
#
sub lib_get_item_id
{
	my $target = shift;
	my $result = -1;

	if ( $target =~ /\((\d+)\)$/ ) {
		$result = $1;
	}
	return $result;
}
########################################################################
#
#	y֐z
#	lib_get_csv_items		bruڒl擾
#
#	y@\z
#	brutH[}bgɊÂ̍ڂ̒l֕܂B
#
#	yz
#	Ver	1.00	2010.05.17	vx TY	VK쐬
#
sub lib_get_csv_items
{
	my $text = shift;
	my $delimiter = shift;
	$text =~ s/(?:\x0D\x0A|[\x0D\x0A])?$/$delimiter/;
	my @items = map( {/^"(.*)"$/s ? scalar($_ = $1, s/""/"/g, $_) : $_} ($text =~ /("[^"]*(?:""[^"]*)*"|[^$delimiter]*)$delimiter/g) );
	foreach my $item (@items) {
		$item =~ s/^'//g;
	}
	return @items;
}

1;
